<!DOCTYPE html>
<!--
To change this license header, choose License Headers in Project Properties.
To change this template file, choose Tools | Templates
and open the template in the editor.
-->
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8">  
        <meta content="IE=edge" http-equiv="X-UA-Compatible"> 
        <meta content="width=device-width,initial-scale=1" name="viewport"> 
        <meta content="Aulas de introcução à computação científica." name="description"> 
        <meta content="Markinho" name="author"> 
        
        <title> Dicionários e cadeias de caracteres </title> 
        
        <link href="./css/bootstrap.min.css" rel="stylesheet">        
        <link href="./css/docs.min.css" rel="stylesheet">
        <link href="./css/carbonads.css" rel="stylesheet">
        <link href="./css/prism.css" rel="stylesheet">
        
        <link href="../imagens/favicon.ico" rel="icon"> 
        
        <script type="text/x-mathjax-config">
            MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
        </script>
        <script type="text/javascript" async
            src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS_CHTML">
        </script>
        
    </head>
    <body>
        
        <!-- Cabeçalho -->
        <div class="v4-tease">
            <a href="http://www.estruturas.ufpr.br">
                <img style="position: absolute; top: 0; left: 0; border: 0;" 
                     src="../imagens/estruturasUFPR.png" alt="Voltar para Estruturas.UFPR">
            </a>
            <a class="navbar-brand" style="position: absolute; left: 360px;" href="../index.html">
                Aulas de Introdução a Computação Científica
            </a>
        </div>
         <!-- FINAL Cabeçalho -->
        
        <!-- Menu superior -->
        <header class="bs-docs-nav navbar navbar-static-top" id="top"> 
            <div class="container"> 
                <div class="navbar-header"> 
                    <button aria-controls="bs-navbar"  
                            class="collapsed navbar-toggle" data-target="#bs-navbar" 
                            data-toggle="collapse" type="button"> 
                        <span class="sr-only">Alternar Navegação</span> 
                        <span class="icon-bar"></span> 
                        <span class="icon-bar"></span> 
                        <span class="icon-bar"></span> 
                    </button>
                </div> 
                <nav class="collapse navbar-collapse" id="bs-navbar"> 
                    <ul class="nav navbar-nav"> 
                        <li class="active"> <a href="lacoslistas.html">Dicionários e cadeias de caracteres</a> </li>
                        <li><a href="#final">Tarefa</a></li>
                    </ul> 
                    <ul class="nav navbar-nav navbar-right"> 
                        <li class="dropdown" id="accountmenu">
                            <a class="dropdown-toggle" data-toggle="dropdown" href="#">Demais tópicos abordados<b class="caret"></b></a>
                            <ul class="dropdown-menu">
                                <li><a href="../index.html#___sec0">Programando equações</a></li>
                                <li><a href="../index.html#___sec1">Laços e listas</a></li>
                                <li><a href="../index.html#___sec2">Funções e ramificações</a></li>
                                <li><a href="../index.html#___sec3">Entrada do usuário e manipulação de erros</a></li>
                                <li><a href="../index.html#___sec4">Arranjos e gráficos de curvas</a></li>            
                                <li><a href="../index.html#___sec6">Dicionários e cadeias de caracteres</a></li>
                                <li><a href="../index.html#___sec7">Introdução a Classes</a></li>            
                                <li><a href="../index.html#___sec9">Programação orientada a objeto</a></li>
                                <li><a href="../index.html#___sec10">Números aleatórios e jogos simples</a></li>
                                <li><a href="../index.html#___secA">Sequências e relações de recorrência</a></li>
                                <li><a href="../index.html#___secB">Programação de equações diferenciais</a></li>
                                <li><a href="../index.html#___secC">Gráficos tridimensionais</a></li>
                                <li><a href="../index.html#___secD">Programação em paralelo</a></li>
                                <li><a href="../index.html#___secE">Interfaces gráficas de usuário (GUI)</a></li>
                                <li><a href="../index.html#___secF">Migrando Python para código compilado</a></li> 
                            </ul>
                        </li> 
                    </ul> 
                </nav> 
            </div> 
        </header>
        <!-- FINAL MENU SUPERIOR -->
        
        <!-- Painel Superior -->
        <div class="bs-docs-header" id="content" tabindex="-1"> 
            <div class="container"> 
                <h1>Dicionários e cadeias de caracteres</h1> 
                <p>Salve seus dados.<br>
                <font size="2px">Prof. Marco André Argenta / PPGECC / UFPR</font></p>
                <div id="carbonads-container">
                    <div class="carbonad">
                        <div id="azcarbon">
                            <a href="./imagens/programando_equacoes.png" target="_blank">
                                <!-- Imagens em 120 px altura e 300 px largura -->
                                <img src="./imagens/dicionariosstrings.png" class="carbonad-image carbonad-img">
                            </a>
                        </div>
                    </div>
                </div> 
            </div> 
        </div>
        <!-- FINAL PAINEL SUPERIOR -->
        
        <!-- Parte principal -->
        <div class="container bs-docs-container">
            <div class="row">
                
                <!-- Conteúdo Principal -->
                <div class="col-md-9" role="main">
                    <div class="bs-docs-section"> 
                        <h1 class="page-header" id="inicio">Dicionários e cadeias de caracteres</h1> 
                        <div class="well">
                            Arquivos são utilizados para armazenamento permanente de informações
                            em um computador. De experiências anteriores com o computador você
                            já utilizou alguma forma de salvar informações em um arquivo
                            para posteriormente acessá-la novamente abrindo o arquivo.
                            Como fazer o python escrever, ler e interpretar os dados
                            novamente é o que vamos ver nessa seção.
                        </div>               
                    </div>
                    <div class="bs-docs-section" id="obj_dic_strings">
                        <h1 class="page-header">Objetivos</h1>

                        <p>Nesta seção vamos aprender a:</p>
                        <ul>
                            <li>Mais sobre leitura de arquivos;</li>
                            <li>Armazenar dados em um novo objeto: dicionário;</li>
                            <li>Interpretar o conteúdo de arquivos através
                            da manipulação das cadeias de caracteres.</li>
                        </ul>
                        
                    </div>
                    <div class="bs-docs-section" id="dicionarios">
                        <h1 class="page-header">Dicionários</h1>

                        <pre><code class="language-python">
arquivo_fig = {'fig1.pdf': 81761, 'fig2.png': 8754}

arquivo_fig['fig3.png'] = os.path.getsize(filename)

for nome in arquivo_fig:
    print 'Tamanho do arquivo %g é %d:' % (nome, arquivo_fig[nome])
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="dicionario_oquee">
                        <h1 class="page-header">Um dicionário é uma generalização
                        de uma lista</h1>

                        <p>Características das listas:</p>
                        <ul>
                            <li>Armazenar uma sequência de elementos em
                                um objeto simples (<code>[1, 3, -1]</code>);</li>
                            <li>Cada elemento -e um objeto Python;</li>
                            <li>Os elementos são indexados por inteiros 0, 1, ...</li>
                        </ul>
                        <p>Dicionários podem indexar objeto em uma coleção através
                        de textos como se fossem listas com índices de texto.</p>                     
                        
                    </div>
                    <div class="bs-docs-section" id="dicionarios_lista">
                        <h1 class="page-header">Índices de listas algumas vezes
                        não são naturais</h1>

                        <p>Índices numéricos algumas vezes não são ideais para 
                        a localização de um elemento em uma coleção de objetos.</p>
                        <p>Suponha que precisamos armazenar as temperaturas em Oslo,
                        Londres e Paris.</p>
                        <p>Solução em listas:</p>
                        <pre><code class="language-python">
temps = [13, 15.4, 17.5]
# temps[0]: Oslo
# temps[1]: Londres
# temps[2]: Paris
print 'A temperatura em Oslo é', temps[0]
                        </code></pre>
                        <p>É possível achar a temperatura através do índice
                        relativo a cidade, mas não seria melhor e mais
                        intuitivo poder fazer <code>temps[Oslo]</code>?</p>
                    </div>
                    <div class="bs-docs-section" id="dicionarios_maps">
                        <h1 class="page-header">Dicionários mapeiam cadeias
                        de caracteres para objetos</h1>

                        <pre><code class="language-python">
# Inicializando o dicionário
temps = {'Oslo': 13, 'Londres': 15.4, 'Paris': 17.5}

# Applicações
print 'A temperatura emn Londres é', temps['Londres']
print 'A temperatura em Oslo é',   temps['Oslo']
                        </code></pre>
                        <p>Importante:</p>
                        <ul>
                            <li>O índice em texto (cadeia de caracteres), como
                                <code>Oslo</code> é chamado de chave (<i>key</i>),
                                enquanto que <code>temps[Oslo]</code> é o valor
                            associado;</li>
                            <li>Um dicionário é uma coleção desordenada de pares
                            chave-valor.</li>
                        </ul>
                        
                    </div>
                    <div class="bs-docs-section" id="dicionarios_inicio">
                        <h1 class="page-header">Inicializando Dicionários</h1>

                        <p>Duas formas de se iniciar uma colação de pares
                        chave-valor:</p>
                        <pre><code class="language-python">
meu_dicio = {'chave1': valor1, 'chave2': valor2, ...}

temps = {'Oslo': 13, 'Londres': 15.4, 'Paris': 17.5}

# ou
meu_dicio = dict(chave1=valor1, chave2=valor2, ...)

temps = dict(Oslo=13, Londres=15.4, Paris=17.5)
                        </code></pre>
                        <p>E para adicionar um novo elemento basta fazer uma
                        atribuição de uma nova chave a um novo valor:</p>
                        <pre><code class="language-python">
>>> temps['Madri'] = 26.0
>>> print temps
{'Oslo': 13, 'Londres': 15.4, 'Paris': 17.5,
 'Madri': 26.0}
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="dicionario_laco">
                        <h1 class="page-header">Laço em dicionários</h1>

                        <p>Correr um laço em um dicionário significa correr
                        um laço sobre as chaves:</p>
                        <pre><code class="language-python">
for chave in dicionario:
    valor = dicionario[chave]
    print valor
                        </code></pre>
                        <p>Exemplo:</p>
                        <pre><code class="language-python">
>>> for cidade in temps:
...   print 'A temperatura de %s é %g' % (cidade, temps[cidade])
...
A temperatura de Paris é 17.5
A temperatura de Oslo é 13
A temperatura de Londres é 15.4
A temperatura de Madri é 26
                        </code></pre>
                        <p>Note que a sequência de chaves é arbitrária! Use
                            o <code>sort</code> se for preciso uma sequência
                        em particular:</p>
                        <pre><code class="language-python">
for cidade in sorted(temps):   # ordem alfabética das chaves
    valor = temps[cidade]
    print valor
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="dicionarios_manip">
                        <h1 class="page-header">Manipulação de dicionários</h1>

                        <p>Pode-se testar por chaves em particular, deletar elementos, etc.</p>
                        <p>O dicionário contém uma chave em particular?</p>
                        <pre><code class="language-python">
>>> if 'Berlim' in temps:
...     print 'Berlim:', temps['Berlim']
... else:
...     print 'Nenhum dado de temperatura para Berlim'
...
Nenhum dado de temperatura para Berlim
>>> 'Oslo' in temps     # expressão condicional padrão
True
                        </code></pre>
                        <p>Apagando um elemento de um dicionário:</p>
                        <pre><code class="language-python">
>>> del temps['Oslo']   # remove a chave Oslo com o valor
>>> temps
{'Paris': 17.5, 'Londres': 15.4, 'Madri': 26.0}
>>> len(temps)          # número de pares chave-valor no dicionário
3
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="dicionario_busca">
                        <h1 class="page-header">As chaves e os valores podem
                        ser encontrados como listas</h1>

                        <p>Somente no Python versão 2:</p>
                        <pre><code class="language-python">
>>> temps.keys()
['Paris', 'Londres', 'Madri']
>>> temps.values()
[17.5, 15.4, 26.0]
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="dicionarios_cuidado">
                        <h1 class="page-header">Cuidado: duas variáveis podem
                        alterar o mesmo dicionário</h1>

                        <p>Dicionários também são mutáveis, então operações
                        produzem visualizações do original:</p>
                        
                        <pre><code class="language-python">
>>> t1 = temps
>>> t1['Estocolmo'] = 10.0    # muda t1
>>> temps                     # temps também é modificado!
{'Estocolmo': 10.0, 'Paris': 17.5, 'Londres': 15.4,
  'Madri': 26.0}
>>> t2 = temps.copy()         # fazendo uma cópia
>>> t2['Paris'] = 16
>>> t1['Paris']               # t1 não modifica
17.5
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="objetos_chaves">
                        <h1 class="page-header">Qualquer objeto constante
                        pode ser utilizado como chave</h1>

                        <p>Até então as chaves eram cadeias de caracteres, mas
                        elas podem ser qualquer objeto imutável:</p>
                        <pre><code class="language-python">
>>> d = {1: 34, 2: 67, 3: 0}   #chave é um inteiro
>>> d = {13: 'Oslo', 15.4: 'Londres'} # sintexe possível
>>> d = {(0,0): 4, (1,-1): 5}  # chave é uma tupla
>>> d = {[0,0]: 4, [-1,1]: 5}  # a lista é mutável!
...
TypeError: unhashable type: 'list'
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="exe_dicionarios">
                        <h1 class="page-header">Exemplo: polinomiais representados
                        por dicionários</h1>

                        <p>A informação no polinômio</p>
                        $$ p(x)=-1 + x^2 + 3x^7 $$
                        <p>pode ser representada por um dicionário com as potências
                        como chaves (inteiros) e os coeficientes como valores 
                        (pontos flutuantes):</p>
                        <pre><code class="language-python">
p = {0: -1, 2: 1, 7: 3.5}
                        </code></pre>
                        <p>Avalie um polinômio tal que \( \sum_{i\in I} c_ix^i \) 
                            para algum \( x \):</p>
                        <pre><code class="language-python">
def aval_poli_dicio(poli, x):
    # o sum em Python pode adicionar elementos de um iterador
    return sum(poli[potencia]*x**potencia for potencia in poli)
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="poli_listas">
                        <h1 class="page-header">Polinomiais também podem ser 
                        representados por listas</h1>

                        <p>O índice da lista corresponde à potência, ou seja, o
                        polinômio \( -1 + x^2 + 3x^7 \) é representado como:</p>
                        <pre><code class="language-python">
p = [-1, 0, 1, 0, 0, 0, 0, 3]
                        </code></pre>
                        <p>O polinômio genérico  \( \sum_{i=0}^N c_ix^i \) é armazenado como
                            <code>[c0, c1, c2, ..., cN]</code>, e sua função de 
                        avaliação fica:</p>
                        <pre><code class="language-python">
def aval_poli_lista(poli, x):
    soma = 0
    for potencia in range(len(poli)):
        soma += poli[potencia]*x**potencia
    return soma
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="poli_dic_lista">
                        <h1 class="page-header">Comparativo</h1>

                        <p>Comparando a representação
                        de um polinômio em um dicionário e uma lista, notamos
                        que o dicionário precisa apenas armazenar os termos
                        diferentes de zero.</p>
                        <p>Por exemplo, comparando para o polinômio \( 1 - x^{200} \):</p>
                        <pre><code class="language-python">
p = {0: 1, 200: -1}         # len(p) é 2
p = [1, 0, 0, 0, ..., 200]  # len(p) é 201
                        </code></pre>
                        <p>Além disso, dicionários podem trabalhar com as
                        potências negativas de forma simples, ex. \( {1\over2}x^{-3} + 2x^4 \):</p>
                        <pre><code class="language-python">
p = {-3: 0.5, 4: 2}
print aval_poli_dicio(p, x=4)
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="recap_lendo_arq">
                        <h1 class="page-header">Uma rápida recapitulada
                        na leitura de arquivos</h1>

                        <pre><code class="language-python">
do_arquivo  = open(filename, 'r') # abre o arquivo para leitura

linha    = do_arquivo.readline()   # lê a próxima linha
conteudo = do_arquivo.read()       # lê o resto do arquivo em cadeias de caracteres
linhas   = do_arquivo.readlines()  # lê o resto do arquivo em lista
for linha in do_arquivo:           # lê o resto do arquivo linha por linha

do_arquivo.close()                # lembre-se de fechar o arquivo!
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="dicionario_arquivo">
                        <h1 class="page-header">Exemplo: lendo dados de um arquivo
                        para um dicionário</h1>

                        <p>Conteúdo do arquivo:</p>
                        <pre>
Oslo:          21.8
Londres:        18.1
Berlim:        19
Paris:         23
Roma:          26
Helsinque:      17.8
                        </pre>
                        <p>Armazene em um dicionário com os nomes das cidades
                        como chaves e as temperaturas como valores.</p>
                        <p>O programa:</p>
                        <pre><code class="language-python">
do_arquivo = open('deg2.dat', 'r')
temps = {}                  # inicie um dicionário vazio
for linha in do_arquivo.readlines():
    cidade, temp = linha.split()
    cidade = cidade[:-1]        # remove o último caractere (:)
    temps[cidade]  = float(temp)
                        </code></pre>                        
                        
                    </div>
                    <div class="bs-docs-section" id="dicionario_arquivo_tab">
                        <h1 class="page-header">Lendo um arquivo com tabela para
                        um dicionário</h1>

                        <p>Um arquivo contendo uma tabela pode ser lindo para um
                        dicionário de um dicionário.</p>
                        <p>O arquivo de dados:</p>
                        <pre>
       A        B       C      D
1     11.7    0.035    2017    99.1
2      9.2    0.037    2019   101.2
3     12.2     no       no    105.2
4     10.1    0.031     no    102.1
5      9.1    0.033    2009   103.3
6      8.7    0.036    2015   101.9
                        </pre>
                        <p>Crie um dicionário <code>dados[p][i]</code> (dicionário
                            de dicionários) para armazenar as medicões número <code>i</code> (1, 2, etc.)
                            da propriedade <code>p</code> (A, B, etc.).</p>
                        <p>Antes de implementar, precisamos desenvolver um plano (algoritmo)
                        para fazer isso:</p>
                        <ol>
                            <li>Examine a primeira linha:
                                <ul>
                                    <li>Divida em palavras;</li>
                                    <li>Inicie um dicionário com os nomes das
                                        propriedades como chaves e dicionários vazios <code>{}</code>
                                    como valores;</li>
                                </ul></li>
                            <li>Para cada uma das linhas remanescentes:
                                <ul>
                                    <li>Divida em palavras;</li>
                                    <li>Para cada palavras após a primeira: se a palavra
                                        não for <code>no</code> converte para ponto 
                                    flutuante e armazene.</li>
                                </ul></li>
                        </ol>
                        <p>MÃOS À OBRA!</p>
                    </div>
                    <div class="bs-docs-section" id="analise_arquivo">
                        <h1 class="page-header">Formato no arquivo de entrada</h1>

                        <p>Precisamos analisar o formato no arquivo de entrada para 
                        descrever um algoritmo para interpretar o conteúdo. Exemplo,
                        variações nos preços das ações de várias companhias:</p>
                        <pre>
Date,Open,High,Low,Close,Volume,Adj Close
2017-05-01,145.100006,148.089996,144.960007,147.509995,57002300,147.509995
2017-04-03,143.710007,145.460007,140.059998,143.649994,20592400,143.649994
2017-03-01,137.889999,144.50,137.050003,143.660004,25273400,143.660004
2017-02-01,127.029999,137.479996,127.010002,136.990005,31497400,136.990005
2017-01-03,115.800003,122.440002,114.760002,121.349998,30616100,120.826149
2016-12-01,110.370003,118.019997,108.25,115.82,30442300,115.320023
...
2010-08-02,260.440002,264.279999,235.559998,243.100006,113748900,31.495928
2010-07-01,254.300003,265.990021,239.600006,257.25,191879900,33.329193
2010-06-01,259.690002,279.009979,242.199982,251.529999,197621600,32.588116
2010-05-03,263.839996,267.880005,199.25,256.880005,236228300,33.281258
                        </pre>
                        <p>Dados de https://finance.yahoo.com/quote/AAPL/history?p=AAPL para
                        a Apple (AAPL) por exemplo. Para outras companhias https://finance.yahoo.com/trending-tickers</p>
                        <p>Formato no arquivo:</p>
                        <ul>
                            <li>Colunas separadas por vírgulas;</li>
                            <li>Primeira coluna é a data e a final é o preço;</li>
                            <li>Os preços inicial em diferentes datas.</li>
                        </ul>
                        <p>Um exemplo de algoritmo para ler esse arquivo de dados de
                            várias companhias:</p>
                        <ol>
                            <li>Pule a primeira linha;</li>
                            <li>Leia linha por linha;</li>
                            <li>Divida cada linha nas vírgulas;</li>
                            <li>Armazene a primeira palavra, data, em uma lista de datas;</li>
                            <li>Armazene a última palavra, preço, em uma lista de preços;</li>
                            <li>Colete as listas de datas e preços e armazene em um
                            dicionário (a chave é a companhia);</li>
                            <li>Maça uma função para ler um arquivo de uma companhia
                            em específico;</li>
                        </ol>
                        <p>Para imprimir:</p>
                        <ol>
                            <li>Converta as datas ano-mês-dia em coordenadas de ano
                                no eixo x para montagem de um gráfico;</li>
                            <li>Observe que os históricos de preços das companhias
                            iniciam em anos diferentes.</li>
                        </ol>
                        <p>Dicas: usar <code>import datetime as dt</code> para criar
                            criar objetos data e <code>import glob</code> para
                            buscar vários arquivos, por exemplo <code>precoAcoes_*.csv</code>.</p>
                        <p>Resultado em escala logarítmica:</p>
                        <div class="text-center">
                            <img src="./imagens/variacaoAcoes.png" alt="Gráfico resultante">
                        </div>
                        
                    </div>
                    
                    <div class="bs-docs-section" id="manipul_cad_carac">
                        <h1 class="page-header">Manipulação de cadeia de 
                        caracteres</h1>

                        <pre><code class="language-python">
>>> s = 'Isso é uma cadeia de caracteres'
>>> s.split()
['Isso', '\xc3\xa9', 'uma', 'cadeia', 'de', 'caracteres']
>>> 'Isso' in s
True
>>> s.find('de')
14
>>> ', '.join(s.split())
'Isso, \xc3\xa9, uma, cadeia, de, caracteres'
                        </code></pre>
                        
                        <p>A manipulação das cadeias de caracteres é a chave
                        para a interpretação do conteúdo de arquivos.</p>
                        <ul>
                            <li>Texto em Python é representado pelas cadeias de caracteres;</li>
                            <li>Inspecionar e manipular essas cadeias é o caminho
                            para entender o conteúdo de arquivos;</li>
                            <li>Plano: primeiro operações básicas, depois exemplos reais.</li>
                        </ul>
                        <p>Um exemplo para ilustração:</p>
                        <pre><code class="language-python">
>>> s = u'Berlim: 18.4 C\u2070 às 16h'
                        </code></pre>
                        <p>*veja mais códigos unicode para caracteres em: https://en.wikipedia.org/wiki/Unicode_subscripts_and_superscripts#Superscripts_and_subscripts_block</p>
                        <p>As cadeias de caracteres se comportam como tuplas (listas imutáveis):</p>
                        <pre><code class="language-python">
>>> s[0]
'B'
>>> s[1]
'e'
>>> s[-1]
'h'
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="extraindo_sub">
                        <h1 class="page-header">Extraindo partes de cadeia de 
                        caracteres</h1>

                        <p>Partes de cadeias de caracteres podem ser obtidas
                        da mesma forma que os cortes em listas:</p>
                        <pre><code class="language-python">
>>> s
'Berlim: 18.4 C às 16h'
>>> s[8:]     # do indice 8 ao final da cadeia de caracteres
'18.4 C às 16h'
>>> s[8:12]   # indice 8, 9, 10 e 11 (não 12!)
'18.4'
>>> s[8:-1]
'18.4 C às 16'
>>> s[8:-8]
'18.4 C'
                        </code></pre>
                        <p>Achando o ínicio de um texto na cadeia de caracteres:</p>
                        <pre><code class="language-python">
>>> s.find('Berlim')  # onde 'Berlim' inicia?
0                     # no indice 0
>>> s.find('h')
21
>>> s.find('Oslo')    # não encontrado
-1
                        </code></pre>                        
                    </div>
                    <div class="bs-docs-section" id="substring_contida">
                        <h1 class="page-header">Checando se um texto está 
                        contido em uma cadeia de caracteres</h1>

                        <pre><code class="language-python">
>>> 'Berlim' in s:
True
>>> 'Oslo' in s:
False

>>> if 'C' in s:
...     print 'C achado'
... else:
...     print 'nenhum C'
...
C achado
                        </code></pre>  
                        
                    </div>
                    <div class="bs-docs-section" id="substring_substituida">
                        <h1 class="page-header">Substituindo um texto por outro</h1>

                        <p>Sintaxe:</p>
                        <pre>
                            s.replace(s1, s2): substitui s1 por s2
                        </pre>
                        <pre><code class="language-python">
>>> s.replace(' ', '__')
'Berlim:__18.4__C__às__4h'
>>> s.replace('Berlim', 'Curitiba')
'Curitiba: 18.4 C às 4h'
                        </code></pre> 
                        <p>Exemplo: substituindo o texto antes dos dois pontos</p>
                        <pre><code class="language-python">
>>> s
'Berlim: 18.4 C às 4h'
>>> s.replace(s[:s.find(':')], 'Curitiba')
'Curitiba: 18.4 C às 4h'
                        </code></pre> 
                        <ol>
                            <li><code>s.find(':')</code> retorna 6;</li>
                            <li><code>s[:6]</code> é Berlim;</li>
                            <li>Berlim é substituido por Curitiba.</li>
                        </ol>
                        
                    </div>
                    <div class="bs-docs-section" id="dividindo_string">
                        <h1 class="page-header">Dividindo uma cadeia de caracteres
                        em uma lista de subtextos</h1>

                        <p><code>s.split(arg)</code> divide em uma lista de
                        subtextos separados pelo argumento arg. Exemplo:</p>
                        <pre><code class="language-python">
>>> s
'Berlim: 18.4 C às 16h'
>>> s.split(':')
['Berlim', ' 18.4 C \xc3\xa0s 16h']
>>> s.split()
['Berlim:', '18.4', 'C', '\xc3\xa0s', '16h']
                        </code></pre> 
                        <p>Tente endenter esse:</p>
                        <pre><code class="language-python">
>>> s.split(':')[1].split()[0]
'18.4'
>>> deg = float(_)  # _ representa o último resultado no console
>>> deg
18.4
                        </code></pre>                         
                    </div>                    
                    <div class="bs-docs-section" id="sring_em_linhas">
                        <h1 class="page-header">Dividindo uma cadeia de caracteres
                        em linhas</h1>

                        <p>Normalmente, os arquivos de dados contém muito texto e
                        queremos separá-lo em linhas. Linhas podem ser separadas
                        por diferentes caracteres de controle em diferentes
                        plataformas:</p>
                        <ul>
                            <li><code>\n</code> no Unix/Linux/Mac</li>
                            <li><code>\r\n</code> no windows</li>
                        </ul>
                        <pre><code class="language-python">
>>> t = '1a linha\n2a linha\n3a linha'     # linha Unix
>>> print t
1a linha
2a linha
3a linha
>>> t.split('\n')
['1a linha', '2a linha', '3a linha']
>>> t.splitlines()
['1a linha', '2a linha', '3a linha']
>>> t = '1a linha\r\n2a linha\r\n3a linha' # Windows
>>> t.split('\n')
['1a linha\r', '2a linha\r', '3a linha']   # não é o resultado esperado!
>>> t.splitlines()                         # qualquer plataforma!
['1a linha', '2a linha', '3a linha']
                        </code></pre> 
                        
                    </div>
                    <div class="bs-docs-section" id="strings_imutaveis">
                        <h1 class="page-header">Cadeias de caracteres são objetos 
                        imutáveis</h1>

                        <p>Não é possível modificar uma cadeia de caracteres (da
                        mesma forma que as listas). Todas as modificações resultam
                        em uma nova cadeia de caracteres.</p>
                        <pre><code class="language-python">
>>> s[18] = 5
...
TypeError: 'str' object does not support item assignment

>>> # criando uma nova cadeia de caracteres e adicionando partes de s:
>>> s2 = s[:19] + '5' + s[21:]
>>> s2
'Berlim: 18.4 C às 5h'
                        </code></pre> 
                        
                    </div>
                    <div class="bs-docs-section" id="removendo_espaco_branco">
                        <h1 class="page-header">Removendo espaços em branco</h1>

                        <pre><code class="language-python">
>>> s = '   texto com espaços em branco antes e depois   \n'
>>> s.strip()
'texto com espaços em branco antes e depois'
>>> s.lstrip()   # removendo da esquerda
'texto com espaços em branco antes e depois   \n'
>>> s.rstrip()   # removendo da direita
'   texto com espaços em branco antes e depois'
                        </code></pre> 
                        
                    </div>
                    <div class="bs-docs-section" id="funcoes_convenientes">
                        <h1 class="page-header">Algumas funções convenientes para
                        cadeias de caracteres</h1>

                        <pre><code class="language-python">
>>> '214'.isdigit()
True
>>> '  214 '.isdigit()
False
>>> '2.14'.isdigit()
False

>>> s.lower()
'berlim: 18.4 c às 4h'
>>> s.upper()
'BERLIM: 18.4 C ÀS 4H'

>>> s.startswith('Berlim')
True
>>> s.endswith('min')
False

>>> '    '.isspace()   # espaços em branco
True
>>> '  \n'.isspace()   # nova linha
True
>>> '  \t '.isspace()  # TAB
True
>>> ''.isspace()       # cadeia de caracteres vazia
False
                        </code></pre> 
                        
                    </div>
                    <div class="bs-docs-section" id="uniao_lista_string">
                        <h1 class="page-header">Unindo cadeias de caracteres</h1>

                        <p>Podemos unir uma lista de cadeias de caracteres para uma
                        única cadeia:</p>
                        <pre><code class="language-python">
>>> strings = ['Newton', 'Secante', 'Bisecção']
>>> ', '.join(strings)
'Newton, Secante, Bisecção'
                        </code></pre> 
                        <p>As operações inversas seriam:</p>
                        <pre><code class="language-python">
t = delimitador.join(listaCadeias)
listaCadeias = t.split(delimitador)
                        </code></pre>
                        <p>Eliminando as duas primeiras palavras em uma linha:</p>
                        <pre><code class="language-python">
>>> linha = 'Esta é uma linha com palavras separadas por espaços'
>>> palavras = linha.split()
>>> linha2 = ' '.join(palavras[2:])
>>> print linha2
'uma linha com palavras separadas por espaços'
                        </code></pre>
                    </div>
                    <div class="bs-docs-section" id="ler_pares_numeros">
                        <h1 class="page-header">Lendo pares de números (x,y) de
                        um arquivo</h1>

                        <p>Arquivo de exemplo:</p>
                        <pre>
(1.3,0)    (-1,2)    (3,-1.5)
(0,1)      (1,0)     (1,1)
(0,-0.01)  (10.5,-1) (2.5,-2.5) 
                        </pre>
                        <p>Algoritmo:</p>
                        <ol>
                            <li>Leia linha por linha;</li>
                            <li>Divida cada linha em palavras;</li>
                            <li>Em cada palavra, remova o parênteses e
                            divida o resto na vírgula.</li>
                        </ol>
                        <p>O código:</p>
                        <pre><code class="language-python">
linhas = open('ler_pares.dat', 'r').readlines()

pares = []   # lista de (n1, n2) pares de números
for linha in linhas:
    palavras = linha.split()
    for palavra in palavras:
        palavra = palavra[1:-1]  # removendo o parênteses
        n1, n2 = palavra.split(',')
        n1 = float(n1);  n2 = float(n2)
        par = (n1, n2)
        pares.append(par)
                        </code></pre>
                        <p>Lista resultante em Python:</p>
                        <pre>
[(1.3, 0.0),
 (-1.0, 2.0),
 (3.0, -1.5),
 (0.0, 1.0),
 (1.0, 0.0),
 (1.0, 1.0),
 (0.0, -0.01),
 (10.5, -1.0),
 (2.5, -2.5)] 
                        </pre>
                        
                    </div>
                    <div class="bs-docs-section" id="lendo_coords_altern">
                        <h1 class="page-header">Solução alternativa: sintaxe Python
                        no formato do arquivo</h1>

                        <p>Suponha que o formato do arquivo</p>
                        <pre>
(1.3, 0)    (-1, 2)    (3, -1.5)
...
                        </pre>
                        <p>Seja um pouco diferente:</p>
                        <pre>
[(1.3, 0),    (-1, 2),    (3, -1.5),
...
]
                        </pre>
                        <p>Chamando a função <code>eval</code> no formato diferente,
                        é possível obter a lista final diretamente:</p>
                        <pre><code class="language-python">
linhas = open('ler_pares.dat', 'r').readlines()

texto = open('ler_pares2.dat', 'r').read()
texto = '[' + texto.replace(')', '),') + ']'
pares = eval(texto)
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="resumo_operac_string">
                        <h1 class="page-header">Resumo de operações com cadeias
                        de caracteres</h1>

                        <pre><code class="language-python">
s = 'Berlim: 18.4 C às 16h'
s[8:17]          # extraindo uma subcadeia de caracteres
s.find(':')      # índice  de onde o primeiro ':' é encontrado
s.split(':')     # dividindo em subcadeias pelo :
s.split()        # dividindo nos espaços em branco
'Berlim' in s    # testa se a subcadeia está em s
s.replace('18.4', '20')
s.lower()        # todas em minúsculo
s.upper()        # todas em maiúsculo
s.split()[4].isdigit()
s.strip()        # remove os espaços em branco no início e final
', '.join(lista_de_palavras)
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="resumo_dicionarios">
                        <h1 class="page-header">Resumo das funcionalidades dos 
                        dicionários</h1>

                        <table border="1">
                            <thead>
                                <tr><th align="center">                  Construção                 </th> <th align="center">                                 Significado                                 </th> </tr>
                            </thead>
                            <tbody>
                                <tr><td align="left">   <code>a = {}</code>                                </td> <td align="left">   inicia um dicionário vazio                                             </td> </tr>
                                <tr><td align="left">   <code>a = {'ponto': [0,0.1], 'valor': 7}</code>    </td> <td align="left">   inicia um dicionário                                                      </td> </tr>
                                <tr><td align="left">   <code>a = dic(ponto=[2,7], valor=3)</code>        </td> <td align="left">   inicia um dicionário com chaves como cadeias de caracteres                                        </td> </tr>
                                <tr><td align="left">   <code>a.update(b)</code>                           </td> <td align="left">   adiciona/atualiza um par chave-calor de <code>b</code> em <code>a</code>             </td> </tr>
                                <tr><td align="left">   <code>a.update(chave1=valor1, chave2=valor2)</code>    </td> <td align="left">   adiciona/atualiza um par chave-calor em <code>a</code>                                 </td> </tr>
                                <tr><td align="left">   <code>a['esconder'] = True</code>                      </td> <td align="left">   adiciona um par chave-calor para <code>a</code>                                     </td> </tr>
                                <tr><td align="left">   <code>a['ponto']</code>                            </td> <td align="left">   pega o valor correspondente a chave <code>ponto</code>                            </td> </tr>
                                <tr><td align="left">   <code>for chave in a:</code>                         </td> <td align="left">   laço sobre as chaves em ordem aleatória                                              </td> </tr>
                                <tr><td align="left">   <code>for chave in sorted(a):</code>                 </td> <td align="left">  laço sobre as chaves em ordem alfabética                                           </td> </tr>
                                <tr><td align="left">   <code>'valor' in a</code>                          </td> <td align="left">   <code>True</code> se a cadeia de caracteres <code>valor</code> é uma chave em <code>a</code>    </td> </tr>
                                <tr><td align="left">   <code>del a['ponto']</code>                        </td> <td align="left">   apaga um par chave-valor de <code>a</code>                                  </td> </tr>
                                <tr><td align="left">   <code>list(a.keys())</code>                        </td> <td align="left">   lista de chaves                                                                </td> </tr>
                                <tr><td align="left">   <code>list(a.values())</code>                      </td> <td align="left">   lista de valores                                                              </td> </tr>
                                <tr><td align="left">   <code>len(a)</code>                                </td> <td align="left">   número de pares chave-valor em <code>a</code>                                  </td> </tr>
                                <tr><td align="left">   <code>isinstance(a, dic)</code>                   </td> <td align="left">   é <code>True</code> se <code>a</code> é um dicionário                       </td> </tr>
                            </tbody>
                        </table>
                        
                    </div>
                    <div class="bs-docs-section" id="final">
                        <h1 class="page-header">Tarefa</h1>
                        <p>
                            Ler os dados do clima da cidade de Oxford de acordo com o fornecido em:
                        </p>              
                        <p><a href="http://www.metoffice.gov.uk/pub/data/weather/uk/climate/stationdata/oxforddata.txt" target="_blank">Oxford.txt</a></p>
                        <p>Objetivos à cumprir:</p>
                        <ul>
                            <li>Ler os dados de local e localização do cabeçalho;</li>
                            <li>Ler os dados das colunas e armazenar em dicionários;</li>
                            <li>Testar para números com anotações especiais como "Provisional";</li>
                            <li>Separar valores estimados (marcados com *) dos medidos;</li>
                            <li>Fazer um gráfico da variação da temperatura máxima (tmax) e da
                            temperatura mínima (tmin) por ano.</li>
                        </ul>
                        <p>Regras básicas:</p>
                        <ul>
                            <li>Documentação das funções;</li>
                            <li>Levantamento de erros;</li>
                            <li>Funções teste.</li>
                        </ul>

                        <!--SOLUÇÃO DA TAREFA-->
                        <button type="button" class="btn btn-info disabled">Solução</button>                        
                        <!--<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#tarefa">Solução</button>-->
                        <!--Final solução da tarefa-->                        

                        <div id="tarefa" class="collapse">
                            <h3> Exemplo de solução: </h3>

                            <pre><code class="language-python">g = 9.81    # m/s**2</code></pre>
                        </div>

                    </div>
                    
                </div>
                <!-- FINAL Conteúdo Principal -->
                
                <!-- Menu lateral -->
                <div class="col-md-3" role="complementary"> 
                    <nav class="bs-docs-sidebar hidden-print hidden-sm hidden-xs affix-top" id="menuLateral"> 
                        <ul class="nav bs-docs-sidenav"> 
                            <li><a href="#inicio">Dicionários e cadeias de caracteres</a></li>
                        </ul> 
                        <a href="#top" class="back-to-top"> Voltar ao topo </a>                 
                    </nav> 
                </div>
                <!-- FINAL Menu lateral -->
                
            </div>
        </div>
        <!-- FINALParte principal -->
        
        <!-- Rodapé -->
        <footer class="bs-docs-footer"> 
            <div class="container"> 
                <ul class="bs-docs-footer-links"> 
                    <li><a href="http://www.estruturas.ufpr.br" target="_blank">estruturas.UFPR</a></li> 
                    <li><a href="http://www.estruturas.ufpr.br/disciplinas/pos-graduacao/introducao-a-computacao-cientifica-com-python/" target="_blank">Introdução à computação científica</a></li> 
                    <li><a href="https://www.python.org/" target="_blank">Python.org</a></li> 
                    <li><a href="https://www.python.org/dev/peps/pep-0257/" target="_blank">Docstring Conventions</a></li> 
                </ul> 
                <p>
                    Prof. Marco André Argenta
                </p> 
            </div> 
        </footer>
        <!-- FINAL Rodapé -->        
        
        <script src="../adicionais/jquery.min.js"></script>
        <script src="../adicionais/bootstrap.min.js"></script>
        <script src="./js/docs.min.js"></script>
        <script src="./js/prism.js"></script>
    </body>
</html>
